



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】android IDE——通过DDMS查看app运行时所占内存情况</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】android IDE——通过DDMS查看app运行时所占内存情况</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 00:18:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在<a href="http://lib.csdn.net/base/android" rel="external nofollow noreferrer">Android</a>内存优化方面，我们不可能做到没有大内存的占用情况。</p>
<p>所以有时候要清楚我们的app到底占用了多少内存，哪一步操作占用了多少的内存。</p>
<p>这时候，<a href="http://lib.csdn.net/base/android" rel="external nofollow noreferrer">android</a>的ddms中提供了一个工具，是可是实时查看app运行时的内存使用情况。</p>
<p>下面我以android studio为例。其实eclipse adt 是一样的。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160512195801769" /></p>
<p>eclipse中也是这个图标。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160512195825957" /></p>
<p>如何使用，图中已经表明的很清楚了。&nbsp;<br />1，找到当前运行的手机&nbsp;<br />2，点击和你app相同包名的进程&nbsp;<br />3，点击update Heap&nbsp;<br />4,切换到Heap视图上点击Cause GC按钮&nbsp;<br />5，根据自己需要点击app进程&nbsp;<br />6，图中的柱状图就是你的app的内存使用情况了</p>
<p>我们可以根据哪一步操作对内存的使用情况而锁定应该优化的地方。</p>
<p><strong>注意事项：</strong>&nbsp;<br />1，Cause GC按钮点击一次就相当于虚拟机请求了一次gc操作&nbsp;<br />2，当内存信息显示后就不需要再点击Cause GC按钮了。Heap视图会定时刷新，对应的操作过程可以看出内存变化。</p>
<p><strong>如何知道程序内存泄漏？</strong>&nbsp;<br />Heap视图中有一行数据是叫data object，即数据对象。它是我们app中大量存在的类类型的对象。&nbsp;<br />在data object中有一列 Total Size ，它的值就是当前进程中所有<a href="http://lib.csdn.net/base/java" rel="external nofollow noreferrer">Java</a>对象的内存总量。&nbsp;<br />一般情况下，这个值决定是否内存泄漏。</p>
<p><strong>如何判断？</strong>&nbsp;<br />1，不断的操作你的app，同时观察Total Size的值。&nbsp;<br />2，Total Size的值一般会稳定在一个正常范围内。&nbsp;<br />3，当我们在不断操作app的时候，内存会有一个先增加（不断的生成对象），后下降（对象被回收）。如果程序的代码处理良好，那么内存占用量会有一个明显的回落，并且稳定在一个正常水平。&nbsp;<br />4，如果你的代码没有很好的释放内存。那么，内存占用量就没有一个明显的回落，并且会越来越高，最终达到上限程序被kill掉。</p>
<p><strong>如何处理？</strong>&nbsp;<br />当我们发现内存泄漏了，我们需要怎么做？&nbsp;<br />一般情况下，我们对自己写的代码了如指掌，可以根据逻辑去判断，当前操作是哪里造成了内存泄漏。然后分析，修改。</p>
<p>但是，如果你在修改别人的代码的时候，这样会把你逼疯的。这里介绍一个工具：<strong>内存分析工具MAT(Memory Analyzer Tool)</strong>，在eclipse中能够当作插件使用。android studio目前我还没试过。不过有客户端。&nbsp;<br />下载地址和使用详情见：www.eclipse.org/mat</p>
<p>from：http://blog.csdn.net/yehui928186846/article/details/51387079</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnvj7x8.html">10000 Reasons&lpar;Matt Redman&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ko7r3q.html">跟我从零基础学习Unity3D开发--U3d脚本注意事项及两个基本函数的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxy3709.html">IT学习网站集结</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgl249.html">如何取消MSSQL自带智能提示步骤，使用第三方智能提示插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2yl2w8.html">Mybatis分页插件 - PageHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/49526109.html">PAC学习框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mv4j8.html">override与final</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1voo38.html">convert NameValueCollection&sol;Dictionary&amp;lt&semi;string&comma; object&amp;gt&semi; to JSON string</a>
		</li>
						<li><a href="https://www.batexi.com/a/96or0549.html">反射-b</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm2og09.html">cocos2dx工程中接入支付宝sdk</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwm7z9.html">BestCoder Round &num;11 &lpar;Div&period; 2&rpar; 题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0nzm8.html">MySQL逻辑备份利器-mydumper</a>
		</li>
						<li><a href="https://www.batexi.com/a/950wmpe8.html">jquery&period;uploadifive 解决上传限制图片或文件大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eypypm9.html">DWM1000 三基站一标签定位HEX</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv255gy9.html">XUnit测试框架-Python unittest</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ww25gq.html">网络协议抓包分析&mdash;&mdash;ARP地址解析协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/9605jr49.html">利用jsoncpp将json字符串转换为Vector</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2w2zpq.html">LR逻辑回归文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/953meev8.html">Couldn&amp;&num;39&semi;t find an AF&lowbar;INET address for</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjypdo8.html">js-权威指南学习笔记13</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9r5wy5rq.html">c&num;中打开Excel文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjd5m59.html">WebFrom  【母版页】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2562kxq.html">Ajax提交用FormData&lpar;&rpar;上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvzwzy8.html">&lbrack;js高手之路&rsqb;深入浅出webpack教程系列2-配置文件webpack&period;config&period;js详解&lpar;上&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q256g33q.html">Python 练习&colon;使用 &num; 号输出长方形</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rdwdz8.html">【读书笔记】iOS-Interface Builder</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyo0xxq.html">mysql 之库&comma; 表的简易操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv277219.html">IDEA项目搭建八&mdash;&mdash;使用MybatisPlus简化数据库交互</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1xxd09.html">Tomcat 部署外部系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllxx60q.html">Jenkins&amp;&num;160&semi;开启用户注册机制及用户权限设置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
